<template>
    <div>
        <v-badge avatar bordered overlap>
            <template v-slot:badge>
                <v-avatar>
                    <span>{{ ordersPending }}</span>
                </v-avatar>
            </template>
            <v-menu :close-on-content-click="closeOnContentClick">
                <template #activator="{ on }">
                    <v-btn small v-on="on" style="background-color: black; width: 1px;">
                        <v-avatar size="40">
                            <v-img
                                src="https://firebasestorage.googleapis.com/v0/b/menu-digital-desarrollo.appspot.com/o/icons%2Ficon-orden.svg?alt=media"
                            >
                            </v-img>
                        </v-avatar>
                    </v-btn>
                </template>
                <template>
                    <NotificationItem
                        ref="NotificationItem"
                        v-for="rest in restaurants"
                        :key="rest.id"
                        :restaurant="rest"
                    ></NotificationItem>
                </template>
            </v-menu>
        </v-badge>
    </div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import { namespace } from 'vuex-class';
import { Restaurant } from '@/model/Restaurant';
import NotificationItem from '@/components/notification/NotificationItem.vue';
import { db } from '@/config/firebase';
import { ORDERS } from '@/config/collectionsName';

const restaurantStore = namespace('RestaurantModule');

@Component({
    components: { NotificationItem }
})
export default class Notification extends Vue {
    @restaurantStore.State
    restaurants!: Restaurant[];
    ordersPendingForRestaurants: Map<string, number> = new Map<string, number>();
    observers: (() => void)[] = [];
    auxReact = 0; // Map isn't reactive but a number variable is.
    cont = 0;
    closeOnContentClick = false;
    trackNotification = new Audio(
        'https://firebasestorage.googleapis.com/v0/b/noteka-d1773.appspot.com/o/notificacion.mp3?alt=media&token=5cddc4e6-0710-494c-a4ac-d2308e363b35'
    );

    created() {
        if (this.restaurants) {
            this.updateObservers(this.restaurants);
        }
    }

    @Watch('restaurants')
    numbersPendingOrders(newsRestaurants: Restaurant[]) {
        if (newsRestaurants) {
            this.updateObservers(newsRestaurants);
        }
    }

    updateObservers(restaurants: Restaurant[]) {
        try {
            this.observers.forEach(val => val()); // Unsuscribe old observers
            this.observers = [];
            for (const res of restaurants) {
                const obs = db
                    .collection(ORDERS)
                    .where('restaurantId', '==', res.id)
                    .where('status', '==', 'PENDING')
                    .onSnapshot(qry => {
                        this.ordersPendingForRestaurants.set(res.id, qry.docs.length);
                        this.auxReact = Math.random();
                        this.cont = this.cont + 1;
                    });
                this.observers.push(obs);

                const notificationSoundObserver = db
                    .collection(ORDERS)
                    .where('restaurantId', '==', res.id)
                    .onSnapshot(snapshot => {
                        snapshot.docChanges().forEach(change => {
                            if (change.type === 'added') {
                                if (this.cont > this.restaurants.length) {
                                    this.trackNotification.play();
                                }
                            }
                        });
                    });

                this.observers.push(notificationSoundObserver);
            }
        } catch (errorCallback) {
            console.log('');
        }
    }

    get ordersPending() {
        return (
            this.auxReact && Array.from(this.ordersPendingForRestaurants.values()).reduce((acc, val) => acc + val, 0)
        );
    }

    beforeDestroy() {
        this.observers.forEach(val => val()); // Unsuscribe old observers
        this.observers = [];
    }
}
</script>

<style type="scss">
.v-menu__content {
    width: 200px;
}
</style>
